#!/bin/bash
# 20150805 build_LiveDVD.sh linux.gnu@yandex.ru
# Distributed under the terms of the GNU General Public License v3.

# Initials params
dev='/dev/sdb'
profile='calculate/desktop/CLS/amd64/binary'

# Download source base
sourcedir='/var/calculate/remote'
mkdir -p $sourcedir/linux $sourcedir/snapshots
cd $sourcedir/linux
wget -c http://mirror.yandex.ru/calculate/CLS/14.16.2/x86_64/cls-14.16.2-x86_64.iso
cd $sourcedir/snapshots
wget -c http://distfiles.gentoo.org/snapshots/portage-latest.tar.xz

# Install build ISO tools
emerge -n app-portage/layman
layman -a calculate
layman -a distros
layman -s calculate
layman -s distros
emerge -u sys-apps/calculate-assemble

# For hardened systems only
if [ `uname -r |grep hardened` != '' ]
  then
    echo 0 > /proc/sys/kernel/grsecurity/tpe
    for i in `ls /proc/sys/kernel/grsecurity/chroot_*`; do echo "0" > $i 2>/dev/null; done
fi

# Build system
profile_=`echo $profile |sed 's/\//-/'`
# Prepare system
cl-assemble --disk $dev --iso cls-14.16.2-x86_64.iso --skip-rebuild-world --no-buildpkg --march x86_64 --source=CLS --name=CLL/Linux Luwrain Desktop/LUWRAIN --profile $profile

# Make system
#cl-make -m --nobuildpkg -p $profile

# Update system
cl-make -u --nobuildpkg -p $profile

# Install luwrain desktop
cp /var/lib/layman/luwrain /mnt/$profile_/var/lib/layman/
sed -i 's/$PORTDIR_OVERLAY"/luwrain\n$PORTDIR_OVERLAY"/' /mnt/$profile_/var/lib/layman/make.conf
mkdir -p /mnt/$profile_/usr/local/bin/
cp build_LiveDVD.sh chroot_luwrain.sh install_LiveDVD.sh /mnt/$profile_/usr/local/bin/
chroot /mnt/$profile_ /usr/local/bin/chroot_luwrain.sh

# Create ISO image
cl-image -p $profile iso

# For hardened systems only
if [ `uname -r |grep hardened` != '' ]
  then
    echo 1 > /proc/sys/kernel/grsecurity/tpe
    for i in `ls /proc/sys/kernel/grsecurity/chroot_*`; do echo "1" > $i 2>/dev/null; done
fi

exit 0
