# Copyright 1999-2015 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header:

EAPI="5"

inherit eutils

DESCRIPTION="VoiceMan is the speech processing daemon designed to collect output from screen reading software used by blind users in one central place and translate it into speech with configured set of speech synthesizers."
HOMEPAGE="http://voiceman.sourceforge.net/"
#SRC_URI="mirror://sourceforge/voiceman/${P}.tar.gz"
SRC_URI="http://www.marigostra.com/download/${P}.tar.gz"

LICENSE="GPL-3"
SLOT="0"
KEYWORDS="~amd64"

IUSE=""

COMMON_DEPEND="
	app-accessibility/emacspeak
	sys-apps/dbus
"

RDEPEND="${COMMON_DEPEND}"
DEPEND="${COMMON_DEPEND}"

src_configure() {
	econf
}

src_compile() {
        default
}

src_install() {
        default
        doinitd "${FILESDIR}/${PN}d"
        readme.gentoo_create_doc
}

pkg_postinst() {
        readme.gentoo_print_elog
}
